export type PlayerAction = 'Rock' | 'Paper' | 'Scissors' | 'Lizard' | 'Spock';
export const PLAYER_OPTIONS: PlayerAction[] = ['Rock', 'Paper', 'Scissors', 'Lizard', 'Spock']

export type PlayResult = 'user' | 'cpu' | 'tie';

export interface Play {
    user: PlayerAction;
    cpu: PlayerAction;
    winner: PlayResult,
}

const ResultMappings = {
    "Scissors": ["Paper", "Lizard"],
    "Paper": ["Rock", "Spock"],
    "Rock": ["Scissors", "Lizard"],
    "Lizard": ["Paper", "Spock"],
    "Spock": ["Scissors", "Rock"],
};

export function GetResult(cpu: PlayerAction, user: PlayerAction): Play {
    if (cpu === user) {
        return {
            user,
            cpu,
            winner: 'tie',
        };
    }

    if (ResultMappings[user].includes(cpu)) {
        return {
            user,
            cpu,
            winner: 'user',
        };
    }
    if (ResultMappings[cpu].includes(user)) {
        return {
            user,
            cpu,
            winner: 'cpu',
        };
    }
    throw 'unrechable'
}
